// Code generated by counterfeiter. DO NOT EDIT.
package loginfakes

import (
	"context"
	"sync"

	"gitlab.eclipse.org/eclipse/xfsc/tsa/login/internal/clients/ocm"
	"gitlab.eclipse.org/eclipse/xfsc/tsa/login/internal/service/login"
)

type FakeOCM struct {
	LoginProofEmailStub        func(context.Context, string) (string, error)
	loginProofEmailMutex       sync.RWMutex
	loginProofEmailArgsForCall []struct {
		arg1 context.Context
		arg2 string
	}
	loginProofEmailReturns struct {
		result1 string
		result2 error
	}
	loginProofEmailReturnsOnCall map[int]struct {
		result1 string
		result2 error
	}
	LoginProofInvitationStub        func(context.Context, string, string) (*ocm.ProofInvitation, error)
	loginProofInvitationMutex       sync.RWMutex
	loginProofInvitationArgsForCall []struct {
		arg1 context.Context
		arg2 string
		arg3 string
	}
	loginProofInvitationReturns struct {
		result1 *ocm.ProofInvitation
		result2 error
	}
	loginProofInvitationReturnsOnCall map[int]struct {
		result1 *ocm.ProofInvitation
		result2 error
	}
	invocations      map[string][][]interface{}
	invocationsMutex sync.RWMutex
}

func (fake *FakeOCM) LoginProofEmail(arg1 context.Context, arg2 string) (string, error) {
	fake.loginProofEmailMutex.Lock()
	ret, specificReturn := fake.loginProofEmailReturnsOnCall[len(fake.loginProofEmailArgsForCall)]
	fake.loginProofEmailArgsForCall = append(fake.loginProofEmailArgsForCall, struct {
		arg1 context.Context
		arg2 string
	}{arg1, arg2})
	stub := fake.LoginProofEmailStub
	fakeReturns := fake.loginProofEmailReturns
	fake.recordInvocation("LoginProofEmail", []interface{}{arg1, arg2})
	fake.loginProofEmailMutex.Unlock()
	if stub != nil {
		return stub(arg1, arg2)
	}
	if specificReturn {
		return ret.result1, ret.result2
	}
	return fakeReturns.result1, fakeReturns.result2
}

func (fake *FakeOCM) LoginProofEmailCallCount() int {
	fake.loginProofEmailMutex.RLock()
	defer fake.loginProofEmailMutex.RUnlock()
	return len(fake.loginProofEmailArgsForCall)
}

func (fake *FakeOCM) LoginProofEmailCalls(stub func(context.Context, string) (string, error)) {
	fake.loginProofEmailMutex.Lock()
	defer fake.loginProofEmailMutex.Unlock()
	fake.LoginProofEmailStub = stub
}

func (fake *FakeOCM) LoginProofEmailArgsForCall(i int) (context.Context, string) {
	fake.loginProofEmailMutex.RLock()
	defer fake.loginProofEmailMutex.RUnlock()
	argsForCall := fake.loginProofEmailArgsForCall[i]
	return argsForCall.arg1, argsForCall.arg2
}

func (fake *FakeOCM) LoginProofEmailReturns(result1 string, result2 error) {
	fake.loginProofEmailMutex.Lock()
	defer fake.loginProofEmailMutex.Unlock()
	fake.LoginProofEmailStub = nil
	fake.loginProofEmailReturns = struct {
		result1 string
		result2 error
	}{result1, result2}
}

func (fake *FakeOCM) LoginProofEmailReturnsOnCall(i int, result1 string, result2 error) {
	fake.loginProofEmailMutex.Lock()
	defer fake.loginProofEmailMutex.Unlock()
	fake.LoginProofEmailStub = nil
	if fake.loginProofEmailReturnsOnCall == nil {
		fake.loginProofEmailReturnsOnCall = make(map[int]struct {
			result1 string
			result2 error
		})
	}
	fake.loginProofEmailReturnsOnCall[i] = struct {
		result1 string
		result2 error
	}{result1, result2}
}

func (fake *FakeOCM) LoginProofInvitation(arg1 context.Context, arg2 string, arg3 string) (*ocm.ProofInvitation, error) {
	fake.loginProofInvitationMutex.Lock()
	ret, specificReturn := fake.loginProofInvitationReturnsOnCall[len(fake.loginProofInvitationArgsForCall)]
	fake.loginProofInvitationArgsForCall = append(fake.loginProofInvitationArgsForCall, struct {
		arg1 context.Context
		arg2 string
		arg3 string
	}{arg1, arg2, arg3})
	stub := fake.LoginProofInvitationStub
	fakeReturns := fake.loginProofInvitationReturns
	fake.recordInvocation("LoginProofInvitation", []interface{}{arg1, arg2, arg3})
	fake.loginProofInvitationMutex.Unlock()
	if stub != nil {
		return stub(arg1, arg2, arg3)
	}
	if specificReturn {
		return ret.result1, ret.result2
	}
	return fakeReturns.result1, fakeReturns.result2
}

func (fake *FakeOCM) LoginProofInvitationCallCount() int {
	fake.loginProofInvitationMutex.RLock()
	defer fake.loginProofInvitationMutex.RUnlock()
	return len(fake.loginProofInvitationArgsForCall)
}

func (fake *FakeOCM) LoginProofInvitationCalls(stub func(context.Context, string, string) (*ocm.ProofInvitation, error)) {
	fake.loginProofInvitationMutex.Lock()
	defer fake.loginProofInvitationMutex.Unlock()
	fake.LoginProofInvitationStub = stub
}

func (fake *FakeOCM) LoginProofInvitationArgsForCall(i int) (context.Context, string, string) {
	fake.loginProofInvitationMutex.RLock()
	defer fake.loginProofInvitationMutex.RUnlock()
	argsForCall := fake.loginProofInvitationArgsForCall[i]
	return argsForCall.arg1, argsForCall.arg2, argsForCall.arg3
}

func (fake *FakeOCM) LoginProofInvitationReturns(result1 *ocm.ProofInvitation, result2 error) {
	fake.loginProofInvitationMutex.Lock()
	defer fake.loginProofInvitationMutex.Unlock()
	fake.LoginProofInvitationStub = nil
	fake.loginProofInvitationReturns = struct {
		result1 *ocm.ProofInvitation
		result2 error
	}{result1, result2}
}

func (fake *FakeOCM) LoginProofInvitationReturnsOnCall(i int, result1 *ocm.ProofInvitation, result2 error) {
	fake.loginProofInvitationMutex.Lock()
	defer fake.loginProofInvitationMutex.Unlock()
	fake.LoginProofInvitationStub = nil
	if fake.loginProofInvitationReturnsOnCall == nil {
		fake.loginProofInvitationReturnsOnCall = make(map[int]struct {
			result1 *ocm.ProofInvitation
			result2 error
		})
	}
	fake.loginProofInvitationReturnsOnCall[i] = struct {
		result1 *ocm.ProofInvitation
		result2 error
	}{result1, result2}
}

func (fake *FakeOCM) Invocations() map[string][][]interface{} {
	fake.invocationsMutex.RLock()
	defer fake.invocationsMutex.RUnlock()
	fake.loginProofEmailMutex.RLock()
	defer fake.loginProofEmailMutex.RUnlock()
	fake.loginProofInvitationMutex.RLock()
	defer fake.loginProofInvitationMutex.RUnlock()
	copiedInvocations := map[string][][]interface{}{}
	for key, value := range fake.invocations {
		copiedInvocations[key] = value
	}
	return copiedInvocations
}

func (fake *FakeOCM) recordInvocation(key string, args []interface{}) {
	fake.invocationsMutex.Lock()
	defer fake.invocationsMutex.Unlock()
	if fake.invocations == nil {
		fake.invocations = map[string][][]interface{}{}
	}
	if fake.invocations[key] == nil {
		fake.invocations[key] = [][]interface{}{}
	}
	fake.invocations[key] = append(fake.invocations[key], args)
}

var _ login.OCM = new(FakeOCM)
